//+------------------------------------------------------------------+
//|                                             VininE_CheckBars.mq4 |
//|                      Copyright  2011, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2011, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

//---- input parameters
extern int        TimeFrame0 =1440;
extern int        CountBar0 =  25;
extern double    Lots      =   0.1;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+

int start()  {
   int i, ticket;
   int cmd=CheckBar(TimeFrame0, CountBar0);

   double price, lots;
   
   int OP_NEV, OP_PRV;

   if (cmd==1) {
      OP_NEV=OP_BUY;
      OP_PRV=OP_SELL;
      price=Ask;
   } else if (cmd==-1) {
      OP_NEV=OP_SELL;
      OP_PRV=OP_BUY;
      price=Bid;
   }

   if (CalcOrders(OP_NEV)>0) return(0);
   lots=Lots+CalcLots(OP_PRV);
   ticket=OrderSend(Symbol(), OP_NEV, lots, price, 0, 0, 0);
   for (i=OrdersTotal()-1;i>=0;i--){
      OrderSelect(i, SELECT_BY_POS);
      if (OrderType()==OP_PRV)
         OrderCloseBy(ticket,OrderTicket());
   }
   return(0);
   
}
//+------------------------------------------------------------------+




int CheckBar(int TimeFrame, int CountBar){
   int Res=0;
   double DN=-(iOpen(Symbol(),TimeFrame,0)-iLow( Symbol(),TimeFrame,iLowest( NULL, TimeFrame, MODE_LOW,  CountBar-1, 1)));
   double UP= (iOpen(Symbol(),TimeFrame,0)-iHigh(Symbol(),TimeFrame,iHighest(NULL, TimeFrame, MODE_HIGH, CountBar-1, 1)));
   
   if (UP>DN) Res=1; else if (UP<DN) Res=-1;

   return(Res);
}

double CalcLots(int OP){
   double Res=0;
   for (int i=0;i<OrdersTotal();i++) {
      OrderSelect(i, SELECT_BY_POS);
      if (OrderType()==OP)
         Res+=OrderLots();
   }
   return(Res);
}

int CalcOrders(int OP) {
   int Res=0;
   for (int i=0;i<OrdersTotal();i++) {
      OrderSelect(i, SELECT_BY_POS);
      if (OrderType()==OP)
         Res++;
   }
   return(Res);
}

